﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace Digg_Sample
{
    public partial class DiggMain : UserControl
    {
        public DiggMain()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(DiggMain_Loaded);
        }

        void DiggMain_Loaded(object sender, RoutedEventArgs e)
        {
            btnSearch.Focus();
        }

        private void btnSearch_Click(object sender, RoutedEventArgs e)
        {
            string topic = txtSearchTopic.Text;

            string diggUrl = string.Format("http://services.digg.com/stories/topic/{0}?count=20&appkey=http%3A%2F%2Fscottgu.com", topic);

            WebClient diggService = new WebClient();
            diggService.DownloadStringCompleted += new DownloadStringCompletedEventHandler(diggService_DownloadStringCompleted);
            diggService.DownloadStringAsync(new Uri(diggUrl));
        }

        void diggService_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                DisplayStories(e.Result);
            }
        }

        void DisplayStories(string xmlContent)
        {
            XDocument xmlStories = XDocument.Parse(xmlContent);

            var stories = from story in xmlStories.Descendants("story")
                          where story.Element("thumbnail") != null
                          select new DiggStory
                          {
                              Id = (int)story.Attribute("id"),
                              Title = (string)story.Element("title"),
                              Description = (string)story.Element("description"),
                              ThumbNail = (string)story.Element("thumbnail").Attribute("src"),
                              HrefLink = (string)story.Attribute("link"),
                              NumDiggs = (int)story.Attribute("diggs"),
                              UserName = (string)story.Element("user").Attribute("name").Value
                          };

            lstStoriesList.ItemsSource = stories;
        }

        /// <summary>
        /// Topic 입력 창에 포커스를 주었을 때 동작
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtSearchTopic_GotFocus(object sender, RoutedEventArgs e)
        {
            txtSearchTopic.Select(0, txtSearchTopic.Text.Length);
        }

        private void lstStoriesList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            DiggStory story = (DiggStory)lstStoriesList.SelectedItem;
            DetailView.DataContext = story;

            DetailView.Visibility = Visibility.Visible;
        }

    }
}
